/* COPYRIGHT (C) GUPTA TECHNOLOGIES, INC. 1984-1989 */
/*
FUNCTION NAME
  PBGBKP - BACKUP AND RESTORE
REVISION HISTORY
  03/27/90 CHY original
EXTERNAL INTERFACE
  FUNCTION
    Main program for testing all the api calls related to BACKUP AND RESTORE
    in version 4
DESCRIPTION
    This utility was designed specifically for Version 4 to test out
    all the api calls for BACKUP AND RESTORE IN LOCAL MODE. If this test
    is to run against the SERVER then the "srvname" should be
    changed to reflect the Server Name.
RETURN
INTERNAL DESCRIPTION
*/
#include "sql.h"
#include "stdio.h"
#include "string.h"
#include "sqlsrv.h"
#include "errsql.h"

/* error defines */
#define APIERROR    1

#define apierr(a) error(a,__LINE__, APIERROR)

static	  SQLTCUR   cur1;
static	  SQLTRCD   rcd;
static	  SQLTCUR   cur2;

	  main()
{

	  SQLTSVH  shandle;
	  char*    password;
	  SQLTDPV  lbmset;
	  SQLTFNP  bkpdir;
	  SQLTFNL  bkpdirl;
	  SQLTRFM  mode=SQLMEOL;
	  SQLTLNG  lognum;
	  SQLTBOO  local,over;

   static char	dbname1[] = "omed";     /* default database name 	    */
   static char	dbname2[] = "xomed";    /* default database name            */
   static char	srvname[] = "";         /* server name		            */
   static char	drop1[] =	        /* CREATE TABLE command 	    */
   "DROP TABLE BBKP";
   static char	ctbcom1[] =		/* CREATE TABLE command 	    */
   "CREATE TABLE BBKP (A NUMBER, B DATETIME, C CHAR(30), D NUMBER)";

   password = 0;
   bkpdir = "\\BACKUP\\OMED";
   bkpdirl = strlen(bkpdir);
   printf("value of bkpdir = %s \n",bkpdir);

   local=1;
   over=1;

  /* CONNECT TO OMED */
  if (rcd = sqlcnc(&cur1,dbname1,0))
    apierr("SQLCNC");
  else
    printf("Connected to OMED \n");

  /* SET LOGBACKUP MODE ON */
  lbmset=1;
  if (rcd = sqlset(cur1,SQLPLBM,(ubyte1p)&lbmset,0))
    apierr("SQLSET");
  else
    printf("Logbackupmode is set to %d \n", lbmset);

  /* DROP TABLES */
  sqlcex(cur1, drop1, 0);

  /*  CREATE THE TABLE : BBKP : BEFORE BACKUP  */
  if (rcd = sqlcex(cur1, ctbcom1, 0))	/* failure on compile and execute?  */
    apierr("SQLCEX");
  else
    printf("Created Table BBKP \n");

  if (rcd = sqlcmt(cur1))
    apierr("SQLCMT");
  else
    printf("Commit \n");

  /* MAKE BACKUP DIRECTORIES */
  system("mkdir \\backup");
  system("mkdir \\backup\\omed");

  /* CONNECT TO SERVER	*/
  if (rcd = sqlcsv(&shandle,srvname,password))
    apierr("SQLCSV");
  
  /* BACKUP DATABASE */
  if (rcd = sqlbdb(shandle,dbname1,0,bkpdir,bkpdirl,local,over))
    apierr("SQLBDB");
  else
    printf("Backed Up Database \n");

  /* RELEASE LOG */
  if (rcd = sqlrel(cur1))
    apierr("SQLREL");
  else
    printf("Released Logs \n");

  /* BACKUP LOGS */
  if (rcd = sqlblf(shandle,dbname1,0,bkpdir,bkpdirl,local,over))
    apierr("SQLBLF");
  else
    printf("Backed Up Logs \n");

  /* CONNECT TO XOMED */
  if (rcd = sqlcnc(&cur2,dbname2,0))
    apierr("SQLCNC");
  else
    printf("Connected to XOMED \n");

  /* DISCONNECT CUR1 */
  if (rcd = sqldis(cur1))
    apierr("SQLDIS");
  else
    printf("Disconnect from OMED \n");

  /* RESTORE DATABASE */
  if (rcd = sqlrdb(shandle,dbname1,0,bkpdir,bkpdirl,local,over))
    apierr("SQLRDB");
  else
    printf("Restored Database \n");
  
  /* ROLLFORWARD TO END */
  sqlrof(shandle,dbname1,0,mode,0,0);

  lognum=0;

/*
	The loop below assumes that all log file backups are on disk.
	If a log file backup is not on disk, lognum is set to a non-zero
	value which causes the loop to terminate.
*/
  while (lognum == 0)
  {
  /* GET NEXT LOG */
  sqlgnl(shandle,dbname1,0,&lognum);

  /* RESTORE LOG FILES */
  sqlrlf(shandle,dbname1,0,bkpdir,bkpdirl,local,over);
  }

  /* END ROLLFORWARD */
  if (rcd = sqlenr(shandle,dbname1,0))
    apierr("SQLENR");
  else
    printf("End Rollforward \n");

  /* CONNECT TO OMED */
  if (rcd = sqlcnc(&cur1,dbname1,0))
    apierr("SQLCNC");
  else
    printf("Connected to OMED \n");

  /* CHECK DATABASE */
  if (rcd = sqlcex(cur1,"CHECK DATABASE",0))
    apierr("SQLCEX");
  else
    printf("Check Database \n");

  /* DISCONNECT FROM OMED */
  if (rcd = sqldis(cur1))
    apierr("SQLDIS");
  else
    printf("Disconnect from OMED \n");
  
  /* RESTORE DATABASE */
  if (rcd = sqlrdb(shandle,dbname1,0,bkpdir,bkpdirl,local,over))
    apierr("SQLRDB");
  else
    printf("Restored Database \n");

  /* ROLLFORWARD TO END */
  sqlrof(shandle,dbname1,0,mode,0,0);

  /* RESTORE LOGS USING DOS COPY */
  system("DEL \\sqlbase\\omed\\*.log");
  system("COPY \\backup\\omed\\*.log \\sqlbase\\omed");

  /* CONTINUE ROLLFORWARD */
  sqlcrf(shandle,dbname1,0);
  
  /* END ROLLFORWARD */
  if (rcd = sqlenr(shandle,dbname1,0))
    apierr("SQLENR");
  else
    printf("End Rollforward \n");

  /* MAKE BACKUP DIRECTORIES */
    system("mkdir \\backup\\snapshot");

   bkpdir = "\\BACKUP\\SNAPSHOT";
   bkpdirl = strlen(bkpdir);

  /* BACKUP SNAPSHOT */
  if (rcd = sqlbss(shandle,dbname1,0,bkpdir,bkpdirl,local,over))
    apierr("SQLBSS");
  else
    printf("Backup Snapshot Database \n");

  /* RESTORE SNAPSHOT */
  if (rcd = sqlrss(shandle,dbname1,0,bkpdir,bkpdirl,local,over))
    apierr("SQLRSS");
  else
    printf("Restore Snapshot \n");

  /* CONNECT TO OMED */
  if (rcd = sqlcnc(&cur1,dbname1,0))
    apierr("SQLCNC");
  else
    printf("Connected to OMED \n");

  /* CHECK DATABASE */
  if (rcd = sqlcex(cur1,"CHECK DATABASE",0))
    apierr("SQLCEX");
  else
    printf("Check Database \n");

  /* DISCONNECT */
  if (rcd = sqldis(cur1))
    apierr("SQLDIS");
  else
    printf("Disconnect from OMED \n");
  if (rcd = sqldis(cur2))
    apierr("SQLDIS");
  else
    printf("Disconnect from XOMED \n");

}

/*
  ERROR - prints an error message for the utility
*/
static	  error(what, line, type)
	  char*     what;		/* description of what happened     */
	  int	    line;		/* line number where error occured  */
	  int	    type;		/* type of error		    */
  {
	  char	    msg[200];		/* error message buffer 	    */

      sqlerr(rcd, msg); 		  /* get the error message	    */
      printf("\nError: %s at line %d: %s\n", what, line, msg);
  }

